[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.18 and 1.63

version 1.18, 2021/10/18 00:33:07 version 1.63, 2021/12/09 02:23:15
Line 1 
Line 1 
 #!/bin/ksh  #!/bin/ksh
 set -e  #       $OpenBSD$
   #
   # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
   #
   # Permission to use, copy, modify, and distribute this software for any
   # purpose with or without fee is hereby granted, provided that the above
   # copyright notice and this permission notice appear in all copies.
   #
   # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
   # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
   # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
   # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
   # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
   # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 scan_dmesg() {  set -o errexit -o pipefail -o nounset
         # no bsort for now  
         sed -n "$1" /var/run/dmesg.boot  
 }  
   
 installed_firmware() {  CFILE=SHA256.sig
         for fw in ${PKGDIR}/$1-firmware*; do  DESTDIR=${DESTDIR:-}
                 [ -e "$fw" ] || continue  FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
                 echo ${fw##*/}  
         done  
 }  
   
 # tmpdir, do_as, unpriv, and unpriv2 are from install.sub  VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
   VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
   
 # Create a temporary directory based on the supplied directory name prefix.  HTTP_FWDIR="$VNAME"
   VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
       /var/run/dmesg.boot | sed '$!d' )
   [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
   
   FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
   FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
 tmpdir() {  tmpdir() {
         local _i=1 _dir          local _i=1 _dir
   
         until _dir="${1?}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do          # If we're not in the installer,
                 ((++_i < 10000)) || return 1          # we have mktemp and a more hostile environment
         done          if [ -x /usr/bin/mktemp ]; then
                   _dir=$( mktemp -d "${1}-XXXXXXXXX" )
           else
                   until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
                       ((++_i < 10000)) || return 1
                   done
           fi
   
         echo "$_dir"          echo "$_dir"
 }  }
   
 # Run a command ($2+) as unprivileged user ($1).  realpath () {
 # Take extra care that after "cmd" no "user" processes exist.          if [ -x /usr/bin/realpath ]; then
 #                  /usr/bin/realpath "$1"
 # Optionally:          elif [ "$1" = "${1%/*}" ]; then
 #       - create "file" and chown it to "user"                  echo "${PWD}/$1"
 #       - after "cmd", chown "file" back to root          else
 #                  echo "$( cd "${1%/*}" && pwd )/${1##*/}"
 # Usage: do_as user [-f file] cmd          fi
 do_as() {  }
         (( $# >= 2 )) || return  
   
         local _file _rc _user=$1  fetch() {
         shift          local _file=$1 _user=_file _exit
   
         if [[ $1 == -f ]]; then          # If we're not in the installer, we have su(1)
                 _file=$2          # and doas(1) is unlikely to be configured.
                 shift 2          if [ -x /usr/bin/su ]; then
                   /usr/bin/su -s /bin/ksh "$_user" -c \
                       "/usr/bin/ftp -D 'Get/Verify' -Vm \
                           -o- '${FWURL}/${_file}'" > "$_file"
                   _exit="$?"
           else
                   /usr/bin/doas -u "$_user" \
                       ftp -D 'Get/Verify' -Vm \
                           -o- "${FWURL}/${_file}" > "$_file"
                   _exit="$?"
         fi          fi
   
         if [[ -n $_file ]]; then          if [ "$_exit" -ne 0 ]; then
                 >$_file                  rm -f "$_file"
                 chown "$_user" "$_file"                  echo "Cannot fetch $_file" >&2
                   return 1
         fi          fi
   }
   
         doas -u "$_user" "$@"  verify() {
         _rc=$?          # On the installer we don't get sha256 -C, so fake it.
           if ! fgrep -qx "SHA256 ($1) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                   echo "Checksum test for $1 failed." >&2
                   return 1
           fi
   }
   
         while doas -u "$_user" kill -9 -1 2>/dev/null; do  devices_needing_firmware() {
                 echo "Processes still running for user $_user after: $@"          local _d _m _grep _dmesgtail _last=''
                 sleep 1  
         done  
   
         [[ -n $_file ]] && chown root "$_file"          # When we're not in the installer, the dmesg.boot can
           # contain multiple boots, so only look in the last one
           _dmesgtail=$( sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )
   
         return $_rc          grep -v '^[[:space:]]*#' "$FWPATTERNS" |
               while read -r _d _m; do
                   _grep="grep"
                   [ "$_last" = "$_d" ] && continue
                   [ "$_m" ] || _m="^${_d}[0-9][0-9]* at "
                   [ "$_m" = "${_m#^}" ] && _grep="fgrep"
   
                   echo "$_dmesgtail" | $_grep -q "$_m" || continue
                   echo "$_d"
                   _last="$_d"
           done
 }  }
   
 unpriv() {  firmware_filename() {
         do_as _sndio "$@"          local _f
           _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
           ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
           echo "$_f"
 }  }
   
 unpriv2() {  firmware_devicename() {
         do_as _file "$@"          local _d="${1##*/}"
           _d="${_d%-firmware-*}"
           echo "$_d"
 }  }
   
 _issue=  installed_firmware() {
 fail() {          for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
         echo $_issue >&2                  [ -e "$fw" ] || continue
         exit 1                  echo "${fw##*/}"
           done
 }  }
   
 VNAME=$(sysctl -n kern.osrelease)  add_firmware () {
 VERSION="${VNAME%.*}${VNAME#*.}"          local _f="${1##*/}" _pkgdir="${DESTDIR}/var/db/pkg"
 FWDIR="$VNAME"          ftp -D "Install" -Vmo- "file:${1}" |
                   tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \
                   -s ",^firmware,${DESTDIR}/etc/firmware," \
                   -C / -zxphf - "+*" "firmware/*"
   
 # TODO: We need the firmware for the system we just installed          # TODO: Should we mark these so real fw_update can -Drepair?
 #       not the one we booted from.  For example:          ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL
 #       * booting from a snapshot bsd.rd that thinks it is the 7.0 release  /^@comment pkgpath/ -1a
 #         will install the firmware from the 7.0 directory instead of  @option manual-installation
 #         from the snapshots dir.  @option firmware
 #       If they're using sysupgrade, then the installer kernel will be correct.  @comment install-script
 #       If we're doing this in the installer we can check what they picked  .
 #       for downloading sets and use that value.  w
 #       Otherwise, the fw_update after first boot will fix it up for us.  EOL
   }
   
 HTTP_FWDIR=$FWDIR  delete_firmware() {
 set -- $(scan_dmesg "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p")          local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
 [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots  
   
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}          # TODO: Check hash for files before deleting
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub          echo "Uninstalling $_pkg"
 PKGDIR=${DESTDIR}/var/db/pkg          _cwd="${_pkgdir}/$_pkg"
 PATTERNS="file:${0%/*}/firmware_patterns"  
   
 fw_update() {          set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
         local _tmpsrc _f _r _remove _i _installed  
         local _src=$FWURL _t=Get _cfile="/tmp/SHA256" _srclocal=false  
         local _d _drivers=$(  
                 last=''  
                 ftp -D "Detecting" -Vmo- $PATTERNS |  
                 while read _d _m; do  
                         grep=grep  
                         [ "$last" = "$_d" ] && continue  
                         [ "$_m" ] || _m="^$_d[0-9][0-9]* at "  
                         [ "$_m" = "${_m#^}" ] && grep=fgrep  
                         $grep -q "$_m" /var/run/dmesg.boot || continue  
                         echo $_d  
                         last=$_d  
                 done  
         )  
   
         if [ -z "$_drivers" ]; then          while read -r c g; do
                 echo "No devices found which need firmware files to be downloaded." >&2                  case $c in
                 return                  @cwd) _cwd="${DESTDIR}$g"
         fi                    ;;
                   @*) continue
                     ;;
                   *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
                     ;;
                   esac
           done < "${_pkgdir}/${_pkg}/+CONTENTS"
   
         if _tmpsrc=$( tmpdir "${DESTDIR}/tmp/fw_update" ); then          # We specifically rm -f here because not removing files/dirs
                 (          # is probably not worth failing over.
                 >$_tmpsrc/t &&          for _r in "${_remove[@]}" ; do
                 $_unpriv cat $_tmpsrc/t                  if [ -d "$_r" ]; then
                 ) >/dev/null 2>&1 ||                          # Try hard not to actually remove recursively
                     rm -r $_tmpsrc                          # without rmdir on the install media.
         fi                          [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                   else
                           rm -f "$_r"
                   fi
           done
   }
   
         [[ ! -d $_tmpsrc ]] &&  usage() {
                 _issue="Cannot create prefetch area" && fail          echo "Usage: fw_install [ -d dir ] [ driver | file [ ... ] ]"
           exit 2
   }
   
         # Cleanup from previous runs.  DOWNLOADDIR=
         rm -f $_cfile $_cfile.sig  while getopts d: name
   do
          case "$name" in
          d) DOWNLOADDIR=$OPTARG ;;
          ?) usage 2 ;;
          esac
   done
   shift $((OPTIND - 1))
   
     _t=Get/Verify  set -A devices -- "$@"
   
         ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&  [ "${devices[*]:-}" ] ||
             _issue="Cannot fetch SHA256.sig" && fail      set -A devices -- $( devices_needing_firmware )
   
         # Verify signature file with public keys.  if [ ! "${devices:-}" ]; then
         ! unpriv -f "$_cfile" \          echo "No devices found which need firmware files to be downloaded."
             signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&          exit
             _issue="Signature check of SHA256.sig failed" && fail  fi
   
         for _d in $_drivers; do  # Have to find the full path to firmware files
                 _f=$( sed -n "s/.*(\($_d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" )  # so we can cd and still find them later.
                 _installed=$( installed_firmware "$_d" )  i=0
   while (( i < "${#devices[@]}" )); do
           f="${devices[$i]}"
           d=$( firmware_devicename "$f" )
           [ "$f" = "$d" ] && f="$( echo "$f"-firmware-*.tgz | sed '$!d' )"
           if [ -e "$f" ]; then
                   if [ "${DOWNLOADDIR:-}" ]; then
                           echo "Cannot download local file $f" >&2
                           exit 2
                   fi
                   devices[$i]="$d:$( realpath "$f" )"
           fi
           i=$((i + 1))
   done
   
                 for _i in $_installed; do  if [ "$DOWNLOADDIR" ]; then
                         if [ "$_f" = "$_i.tgz" ]; then          if ! cd "$DOWNLOADDIR"; then
                                 echo "Firmware for $_d already installed ($_installed)"                  echo "Unable to use $DOWNLOADDIR, make sure it is a directory"
                                 continue 2                  exit 2
                         fi          fi
                 done  else
           TMPDIR=$( tmpdir "${DESTDIR}/tmp/fw_install" )
           cd "$TMPDIR"
   fi
   
                 rm -f /tmp/h /tmp/fail  fetch "$CFILE"
   ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
       echo "Signature check of SHA256.sig failed" >&2 && exit 1
   
                 # Fetch firmware file and create a checksum by piping through  for d in "${devices[@]}"; do
                 # sha256. Create a flag file in case ftp failed. Firmware          f="${d##*:}"
                 # from net is written to the prefetch area.          if [ "$f" = "$d" ]; then
                 ( $_unpriv ftp -D "$_t" -Vmo - "$_src/$_f" || >/tmp/fail ) |                  f=$( firmware_filename "$d" || true )
                 ( $_srclocal && unpriv2 sha256 -b >/tmp/h ||                  [ "$f" ] || continue
                     unpriv2 -f /tmp/h sha256 -bph /tmp/h >"$_tmpsrc/$_f" )          else
                   d="${d%:*}"
           fi
   
                 # Handle failed transfer.          set -A installed -- $( installed_firmware "$d" )
                 if [[ -f /tmp/fail ]]; then  
                         rm -f "$_tmpsrc/$_f"  
                         _issue="Fetching of $_f failed!"  
                         fail  
                 fi  
   
                 # Verify firmware by comparing its checksum with SHA256.          if [ ! "${DOWNLOADDIR:-}" ] && [ "${installed:-}" ]; then
                 if fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then                  for i in "${installed[@]:-}"; do
                         #_unver=$(rmel $_f $_unver)                          if [ "${f##*/}" = "$i.tgz" ]; then
                         true                                  echo "$i already installed"
                 else                                  continue 2
                         [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"                          fi
                         _issue="Checksum test for $_f failed."                  done
                         fail          fi
                 fi  
   
                 # TODO: Check hash for files before deleting          if [ ! -e "$f" ]; then
                 if [ "$_installed" ] && [ -e "${PKGDIR}/$_installed/+CONTENTS" ]; then                  fetch  "$f" || continue
                         echo "Uninstalling $_installed"                  verify "$f" || continue
                         cwd=${PKGDIR}/$_installed          elif [ "${DOWNLOADDIR:-}" ]; then
                   echo "Already have $f"
                   verify "$f" || continue
           fi
   
                         set -A _remove -- "${cwd}/+CONTENTS" "${cwd}"          [ "${DOWNLOADDIR:-}" ] && continue
   
                         while read c g; do          if [ "${installed:-}" ]; then
                                 case $c in                  for i in "${installed[@]}"; do
                                 @cwd) cwd="${DESTDIR}/$g"                          delete_firmware "$i"
                                   ;;                  done
                                 @*) continue          fi
                                   ;;  
                                 *)  set -A _remove -- "$cwd/$c" "${_remove[@]}"  
                                   ;;  
                                 esac  
                         done < "${PKGDIR}/$_installed/+CONTENTS"  
   
                         for _r in "${_remove[@]}" ; do          add_firmware "$f"
                                 if [ -d "$_r" ]; then  done
                                         # Try hard not to actually remove recursively  
                                         # without rmdir on the install media.  
                                         [ "$_r/*" = $( echo "$_r"/* ) ] && rm -rf "$_r"  
                                 else  
                                         rm -f "$_r"  
                                 fi  
                         done  
                 fi  
   
         # TODO: Add some details about the install to +CONTENTS like pkg_add  
         # TODO: Or, maybe we save the firmware someplace and make pkg_add reinstall  
                 echo "Installing $_f"  
                 tar -zxphf "$_tmpsrc/$_f" -C "${DESTDIR}/etc" "firmware/*"  
                 mkdir -p ${PKGDIR}/${_f%.tgz}/  
                 tar -zxphf "$_tmpsrc/$_f" -C "${PKGDIR}/${_f%.tgz}" "+*"  
                 ed -s "${PKGDIR}/${_f%.tgz}/+CONTENTS" <<EOL  
 /^@comment pkgpath/ -1a  
 @option manual-installation  
 @option firmware  
 @comment install-script  
 .  
 w  
 EOL  
         done  
 }  
   
 fw_update  

Legend:
Removed from v.1.18  
changed lines
  Added in v.1.63

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>